var prevInfowindow = 0;
var checkBoxes = [];
var kmlLayers = [];
var imgLayers = [];
var markers = [];
var map;

var	thumbnailWidth = '300';

var	lat = -25.0;
var lng = 127.0;
var	zlv = 3;

var xmlDocMarker;

function initialize() 
{	
	var myLatlng = new google.maps.LatLng(lat, lng);  
	var mapOptions = 
	{	zoom: zlv,	center: myLatlng,
		panControl: false, zoomControl: false, scaleControl: true,
		streetViewControl: false
	};
	map = new google.maps.Map(document.getElementById('map-canvas'), mapOptions);
	
	xmlDocMarker = parseXMLDoc("./recordsMarker.xml");
 	
	addMarkers();
}

function deleteMarkers() 
{	for (var i = 0; i < markers.length; i++) markers[i].setMap(null);
 	markers = [];
	infowindows = [];
}

function deleteAllLayers() 
{	for (var i = 0; i < kmlLayers.length; i++) kmlLayers[i].setMap(null);
  	for (var i = 0; i < checkBoxes.length; i++) checkBoxes[i].checked = false;
	for (var i = 0; i < imgLayers.length; i++) imgLayers[i].setMap(null);
	kmlLayers = [];
	checkBoxes = [];
	imgLayers = [];
	map.setZoom(zlv);
}

function checkBoxControl(checkBoxName, checkState)
{	for (var i = 0; i < checkBoxes.length; i++) 
		if(checkBoxes[i].name == checkBoxName) checkBoxes[i].checked = checkState;
}

function deleteLayers(kmlFileName, checkBoxName) 
{	var tmpLayers =[];
	for (var i = 0; i < kmlLayers.length; i++) 
	{	if(kmlLayers[i].getUrl() == kmlFileName) kmlLayers[i].setMap(null);
		else tmpLayers.push(kmlLayers[i]);
	}
	for (var i = 0; i < checkBoxes.length; i++) 
		if(checkBoxes[i].name == checkBoxName) checkBoxes[i].checked = false;
	
	kmlLayers = [];
	kmlLayers = tmpLayers;
	
	if(kmlLayers.length == 0&&imgLayers.length ==0) map.setZoom(zlv);
	else if(imgLayers.length ==0)
		map.fitBounds(kmlLayers[kmlLayers.length - 1].getDefaultViewport());
	else if(klmLayers.length ==0)
		map.fitBounds(imgLayers[imgLayers.length - 1].getDefaultViewport());
}

function resetZoom() 
{	map.setZoom(zlv);
	if(isMobile) 
	{	var myLatlng = new google.maps.LatLng(15.0, 127.378857);  
		map.setCenter(myLatlng);
}	}

//Adding Markers and Layers by Google maps API
function registerEventListener(geoCoord, title, contentString)
{	var location = new google.maps.LatLng(geoCoord[0], geoCoord[1]);
	var infowindow = new google.maps.InfoWindow({content: contentString,maxWidth: thumbnailWidth});
	var marker = new google.maps.Marker({position: location, map: map, title: title, animation: google.maps.Animation.DROP});
	google.maps.event.addListener(marker, 'click', 
		function() 
		{	
			if(prevInfowindow) 
			{	if(prevInfowindow.getPosition().equals(infowindow.getPosition())) 
				{	prevInfowindow.close(); prevInfowindow = 0;
					marker.setAnimation(null);
				}
				else
				{	prevInfowindow.close();
					for(var i=0; i<markers.length;i++)markers[i].setAnimation(null);
					marker.setAnimation(google.maps.Animation.BOUNCE);
					infowindow.open(map, marker);
					prevInfowindow = infowindow;
			}	}
			else
			{	infowindow.open(map, marker);
				marker.setAnimation(google.maps.Animation.BOUNCE);
				prevInfowindow = infowindow;
		}	}	
	);
	return marker;
}

function addMarkers()
{	deleteMarkers();
	for (var i = 0; i<xmlDocMarker.getElementsByTagName("marker").length; i++)
	{	var thisMarker = xmlDocMarker.getElementsByTagName("marker")[i];
		var title = thisMarker.attributes[0].nodeValue;
		var contentString = getNodeValue(thisMarker,"desc");
		
		if(thisMarker.getElementsByTagName("overLayer"))
		{	for (var j = 0; j<thisMarker.getElementsByTagName("overLayer").length; j++) 
			{	var thisLayer = thisMarker.getElementsByTagName("overLayer")[j];
				var funcName;
				if(getNodeValue(thisLayer, "type").toLowerCase() == "map") 
				funcName = "addMapOverLayer(this);";
				else funcName = "addRouteOverLayer(this);";
				
				contentString += '<br><input onclick="'+funcName+'" type=checkbox name="'+
								 thisLayer.attributes[0].nodeValue +'" value="' +
								 getNodeValue(thisLayer, "data") + '">' + 
								 getNodeValue(thisLayer, "label");
		}	}
		
		getNodeValue(thisMarker,"portrait")
		contentString += '<a href="'+getNodeValue(thisMarker,"url")+'" target="_blank"><br>' +
						 '<img src="' + getNodeValue(thisMarker,"thumbnail") + 
						 '"' +getNodeValue(thisMarker,"portrait")+'=' + thumbnailWidth + '></a>'
		
		markers.push
		(	registerEventListener
			(	[getNodeValue(thisMarker,"lat"), getNodeValue(thisMarker,"lng")], 
				title, 
				contentString
		)	);  
	}
}

function addMapOverLayer(checkBox)
{	if(checkBox.checked) 
	{	for (var j = 0; j<xmlDocMarker.getElementsByTagName("overLayer").length;j++)
		{	if(checkBox.name == xmlDocMarker.getElementsByTagName("overLayer")[j].attributes[0].nodeValue)
			{	var thisLayer = xmlDocMarker.getElementsByTagName("overLayer")[j];
				var imgBounds = new google.maps.LatLngBounds(
				new google.maps.LatLng(getNodeValue(thisLayer, "lat1"), getNodeValue(thisLayer, "lng1")),
				new google.maps.LatLng(getNodeValue(thisLayer, "lat2"), getNodeValue(thisLayer, "lng2")));
			
				var maplayer = new google.maps.GroundOverlay(
				getNodeValue(thisLayer,"data"),imgBounds);
					
				maplayer.setMap(map); map.fitBounds(imgBounds);
				imgLayers.push(maplayer);	
		}	}
		checkBoxes.push(checkBox);
	}
	else
	{	for(var k=0; k<imgLayers.length; k++){ imgLayers[k].setMap(null);}
		imgLayers = []; 
}	}

function addRouteOverLayer(checkBox)
{	if(checkBox.checked) 
	{	var Layer = new google.maps.KmlLayer({url: checkBox.value});
		Layer.setMap(map); 
		kmlLayers.push(Layer);
		checkBoxes.push(checkBox);
	}
	else deleteLayers(checkBox.value, checkBox.name);
}

//XML Parsers 
function parseXMLDoc(xmlFileName)
{	var xmlhttp=new XMLHttpRequest();
	xmlhttp.open("GET",xmlFileName,false);
	xmlhttp.send();
	return xmlhttp.responseXML; 
}

function getNodeValue(baseElement, searchItem)
{	return baseElement.getElementsByTagName(searchItem)[0].childNodes[0].nodeValue;
}

